SystemOrganization addCategory: #SW2PR!

Object subclass: #SW2PR
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SW2PR'!

!SW2PR methodsFor: 'private' stamp: 'lr 3/20/2008 09:20'!
read: aString in: aDirectory do: aBlock
	| stream |
	stream := aDirectory oldFileNamed: aString.
	^ [ aBlock value: stream ] ensure: [ stream close ]! !

!SW2PR methodsFor: 'exporting' stamp: 'lr 3/20/2008 08:25'!
export: aStructure
	self export: aStructure to: FileDirectory default! !

!SW2PR methodsFor: 'exporting' stamp: 'lr 3/20/2008 09:33'!
export: aStructure to: aDirectory
	| directory |
	(aStructure localPropertyAt: #internalStylesheet) ifNotNilDo: [ :stylesheet |
		self 
			write: aStructure title , '.css' in: aDirectory
			do: [ :stream | stream ascii; nextPutAll: stylesheet ] ].
	(aStructure isKindOf: SWPage) ifTrue: [
		self 
			write: aStructure title , '.txt' in: aDirectory
			do: [ :stream | SWVisitorRendererWiki render: aStructure document on: stream ascii ] ].
	(aStructure isKindOf: SWFolder) ifTrue: [
		directory := aDirectory directoryNamed: aStructure title.
		directory assureExistence.
		aStructure children do: [ :each |
			self export: each to: directory ] ].
	(aStructure isKindOf: SWResource) ifTrue: [
		self 
			write: aStructure title , '.bin' in: aDirectory
			do: [ :stream | stream binary; nextPutAll: aStructure data ].
		self
			write: aStructure title , '.mim' in: aDirectory
			do: [ :stream | stream ascii; nextPutAll: aStructure mimetype ] ]! !

!SW2PR methodsFor: 'importing' stamp: 'lr 3/20/2008 09:29'!
import: aDirectory
	| structure |
	structure := PRPage named: 'root'.
	self import: aDirectory into: structure.
	^ structure childrenDecoration children first
		instVarNamed: 'parent' put: nil;
		yourself! !

!SW2PR methodsFor: 'private' stamp: 'lr 3/20/2008 09:09'!
write: aString in: aDirectory do: aBlock
	| stream |
	stream := aDirectory forceNewFileNamed: aString.
	^ [ aBlock value: stream ] ensure: [ stream close ]! !

!SW2PR methodsFor: 'importing' stamp: 'lr 3/20/2008 08:59'!
import
	^ self import: FileDirectory default! !

!SW2PR methodsFor: 'importing' stamp: 'lr 3/20/2008 09:20'!
import: aDirectory into: aStructure
	| structure |
	aDirectory directoryNames do: [ :each |
		structure := PRPage named: each.
		aStructure addChild: structure.
		self
			import: (aDirectory directoryNamed: each) 
			into: structure ].
	aDirectory fileNames do: [ :each |
		(each endsWith: '.txt') ifTrue: [
			structure := aStructure childrenDecoration
				at: (each allButLast: 4)
				ifAbsent: [ 
					structure := PRPage named: (each allButLast: 4).
					aStructure addChild: structure ].
			self
				read: each in: aDirectory
				do: [ :stream | 
					stream converter: MacRomanTextConverter new; ascii.
					structure contents: stream contents ] ].
		(each endsWith: '.bin') ifTrue: [
			structure := PRFile named: (each allButLast: 4).
			aStructure addChild: structure.
			self
				read: each in: aDirectory
				do: [ :stream | ] ] ]! !
